import { default as ConnectionBase } from './base';
/**
 * messaging_only 専用のクラス
 * 利用する場合は Sora 側での設定が必要
 * Role は "sendonly" に固定される
 */
export default class ConnectionMessaging extends ConnectionBase {
    /**
     * Sora へ接続するメソッド、legacyStream は利用できない
     *
     * @example
     * ```typescript
     * const messaging = connection.messaging("sora");
     * await messaging.connect();
     * ```
     *
     * @public
     */
    connect(): Promise<void>;
    /**
     * マルチストリームで Sora へ接続するメソッド
     */
    private multiStream;
}
