/**
 * sora-js-sdk
 * WebRTC SFU Sora JavaScript SDK
 * @version: 2024.2.2
 * @author: Shiguredo Inc.
 * @license: Apache-2.0
 **/
async function _(r, e) {
  if (e.audio && typeof e.audio != "boolean")
    for (const t of r.getAudioTracks())
      await t.applyConstraints(e.audio);
  if (e.video && typeof e.video != "boolean")
    for (const t of r.getVideoTracks())
      await t.applyConstraints(e.video);
}
const m = "websocket", R = "datachannel", y = "sendrecv", E = "sendonly", M = "recvonly", G = "redirect", b = "offer", W = "answer", x = "candidate", U = "switched", F = "ping", $ = "pong", H = "req-stats", V = "stats", B = "close", O = "re-offer", J = "re-answer", C = "disconnect", Y = "notify", j = "push", A = "update", K = "signaling", z = "push", q = "notify", Q = "stats";
class X extends Error {
  constructor() {
    super("DISCONNECT-WAIT-TIMEOUT-ERROR");
  }
}
class Z extends Error {
  constructor() {
    super("DISCONNECT-INTERNAL-ERROR");
  }
}
class ee extends Error {
  constructor() {
    super("DISCONNECT-DATA-CHANNEL-ERROR");
  }
}
function k() {
  const r = window.navigator.userAgent.toLocaleLowerCase();
  return r.indexOf("edge") !== -1 ? "edge" : r.indexOf("chrome") !== -1 && r.indexOf("edge") === -1 ? "chrome" : r.indexOf("safari") !== -1 && r.indexOf("chrome") === -1 ? "safari" : r.indexOf("opera") !== -1 ? "opera" : r.indexOf("firefox") !== -1 ? "firefox" : null;
}
function te() {
  const r = [
    "urn:ietf:params:rtp-hdrext:sdes:mid",
    "urn:ietf:params:rtp-hdrext:sdes:rtp-stream-id",
    "urn:ietf:params:rtp-hdrext:sdes:repaired-rtp-stream-id"
  ];
  if (!window.RTCRtpSender || !RTCRtpSender.getCapabilities)
    return !1;
  const e = RTCRtpSender.getCapabilities("video");
  if (!e)
    return !1;
  const t = e.headerExtensions.map((n) => n.uri);
  return r.every(
    (n) => t.includes(n)
  );
}
function ne(r) {
  if (typeof r != "object" || r === null)
    throw new Error(
      "Failed to parse options dataChannels. Options dataChannels element must be type 'object'"
    );
  const e = r, t = {};
  return typeof e.label == "string" && (t.label = e.label), typeof e.direction == "string" && (t.direction = e.direction), typeof e.ordered == "boolean" && (t.ordered = e.ordered), typeof e.compress == "boolean" && (t.compress = e.compress), typeof e.maxPacketLifeTime == "number" && (t.max_packet_life_time = e.maxPacketLifeTime), typeof e.maxRetransmits == "number" && (t.max_retransmits = e.maxRetransmits), typeof e.protocol == "string" && (t.protocol = e.protocol), Array.isArray(e.header) && (t.header = e.header), t;
}
function ie(r) {
  const e = [];
  for (const t of r)
    e.push(ne(t));
  return e;
}
function se() {
  return k() === "safari";
}
function ae() {
  return k() === "firefox";
}
function oe(r, e, t, i, n, o) {
  if (e !== "sendrecv" && e !== "sendonly" && e !== "recvonly")
    throw new Error("Unknown role type");
  if (t == null)
    throw new Error("channelId can not be null or undefined");
  const s = {
    type: "connect",
    sora_client: "Sora JavaScript SDK 2024.2.2",
    environment: window.navigator.userAgent,
    role: e,
    channel_id: t,
    sdp: r,
    audio: !0,
    video: !0
  };
  if (e === "sendrecv" && n.multistream === !1)
    throw new Error(
      "Failed to parse options. Options multistream must be true when connecting using 'sendrecv'"
    );
  o === !0 && (s.redirect = !0), typeof n.multistream == "boolean" && (s.multistream = n.multistream), typeof n.simulcast == "boolean" && (s.simulcast = n.simulcast);
  const a = ["r0", "r1", "r2"];
  n.simulcastRid !== void 0 && 0 <= a.indexOf(n.simulcastRid) && (s.simulcast_rid = n.simulcastRid), typeof n.spotlight == "boolean" && (s.spotlight = n.spotlight), "spotlightNumber" in n && (s.spotlight_number = n.spotlightNumber);
  const c = ["none", "r0", "r1", "r2"];
  n.spotlightFocusRid !== void 0 && 0 <= c.indexOf(n.spotlightFocusRid) && (s.spotlight_focus_rid = n.spotlightFocusRid), n.spotlightUnfocusRid !== void 0 && 0 <= c.indexOf(n.spotlightUnfocusRid) && (s.spotlight_unfocus_rid = n.spotlightUnfocusRid), i !== void 0 && (s.metadata = i), n.signalingNotifyMetadata !== void 0 && (s.signaling_notify_metadata = n.signalingNotifyMetadata), n.forwardingFilters !== void 0 && (s.forwarding_filters = n.forwardingFilters), n.forwardingFilter !== void 0 && (s.forwarding_filter = n.forwardingFilter), n.clientId !== void 0 && (s.client_id = n.clientId), n.bundleId !== void 0 && (s.bundle_id = n.bundleId), typeof n.dataChannelSignaling == "boolean" && (s.data_channel_signaling = n.dataChannelSignaling), typeof n.ignoreDisconnectWebSocket == "boolean" && (s.ignore_disconnect_websocket = n.ignoreDisconnectWebSocket);
  const d = ["audioCodecType", "audioBitRate"], u = [
    "audioOpusParamsChannels",
    "audioOpusParamsMaxplaybackrate",
    "audioOpusParamsStereo",
    "audioOpusParamsSpropStereo",
    "audioOpusParamsMinptime",
    "audioOpusParamsPtime",
    "audioOpusParamsUseinbandfec",
    "audioOpusParamsUsedtx"
  ], T = [
    "videoCodecType",
    "videoBitRate",
    "videoVP9Params",
    "videoH264Params",
    "videoH265Params",
    "videoAV1Params"
  ], l = Object.assign({}, n);
  Object.keys(l).filter((h) => {
    h === "audio" && typeof l[h] == "boolean" || h === "video" && typeof l[h] == "boolean" || 0 <= d.indexOf(h) && l[h] !== null || 0 <= u.indexOf(h) && l[h] !== null || 0 <= T.indexOf(h) && l[h] !== null || delete l[h];
  }), l.audio !== void 0 && (s.audio = l.audio);
  const P = Object.keys(l).some((h) => 0 <= d.indexOf(h));
  s.audio && P && (s.audio = {}, "audioCodecType" in l && (s.audio.codec_type = l.audioCodecType), "audioBitRate" in l && (s.audio.bit_rate = l.audioBitRate));
  const L = Object.keys(l).some((h) => 0 <= u.indexOf(h));
  s.audio && L && (typeof s.audio != "object" && (s.audio = {}), s.audio.opus_params = {}, "audioOpusParamsChannels" in l && (s.audio.opus_params.channels = l.audioOpusParamsChannels), "audioOpusParamsMaxplaybackrate" in l && (s.audio.opus_params.maxplaybackrate = l.audioOpusParamsMaxplaybackrate), "audioOpusParamsStereo" in l && (s.audio.opus_params.stereo = l.audioOpusParamsStereo), "audioOpusParamsSpropStereo" in l && (s.audio.opus_params.sprop_stereo = l.audioOpusParamsSpropStereo), "audioOpusParamsMinptime" in l && (s.audio.opus_params.minptime = l.audioOpusParamsMinptime), "audioOpusParamsPtime" in l && (s.audio.opus_params.ptime = l.audioOpusParamsPtime), "audioOpusParamsUseinbandfec" in l && (s.audio.opus_params.useinbandfec = l.audioOpusParamsUseinbandfec), "audioOpusParamsUsedtx" in l && (s.audio.opus_params.usedtx = l.audioOpusParamsUsedtx)), l.video !== void 0 && (s.video = l.video);
  const v = Object.keys(l).some((h) => 0 <= T.indexOf(h));
  if (s.video && v && (s.video = {}, "videoCodecType" in l && (s.video.codec_type = l.videoCodecType), "videoBitRate" in l && (s.video.bit_rate = l.videoBitRate), "videoVP9Params" in l && (s.video.vp9_params = l.videoVP9Params), "videoH264Params" in l && (s.video.h264_params = l.videoH264Params), "videoH265Params" in l && (s.video.h265_params = l.videoH265Params), "videoAV1Params" in l && (s.video.av1_params = l.videoAV1Params)), s.simulcast && !te() && e !== "recvonly")
    throw new Error("Simulcast can not be used with this browser");
  return Array.isArray(n.dataChannels) && 0 < n.dataChannels.length && (s.data_channels = ie(n.dataChannels)), n.audioStreamingLanguageCode !== void 0 && (s.audio_streaming_language_code = n.audioStreamingLanguageCode), s;
}
function re(r) {
  return r.data && Array.isArray(r.data) ? r.data : r.metadata_list && Array.isArray(r.metadata_list) ? r.metadata_list : [];
}
function ce(r, e, t) {
  const i = (o) => {
    if (o && typeof o == "object") {
      let s = null;
      try {
        s = Object.keys(JSON.parse(JSON.stringify(o)));
      } catch {
      }
      s && Array.isArray(s) ? s.filter((a) => {
        console.group(a), i(o[a]), console.groupEnd();
      }) : console.info(o);
    } else
      console.info(o);
  };
  let n = "";
  window.performance && (n = `[${(window.performance.now() / 1e3).toFixed(3)}]`), r && (n = `${n}[${r}]`), console.info !== void 0 && console.group !== void 0 ? (console.group(`${n} ${e}`), i(t), console.groupEnd()) : console.log(`${n} ${e}
`, t);
}
class g extends Error {
}
function N(r, e, t) {
  const i = new Event(r);
  try {
    i.data = JSON.parse(JSON.stringify(e));
  } catch {
    i.data = e;
  }
  return i.transportType = t, i;
}
function le(r) {
  return {
    binaryType: r.binaryType,
    bufferedAmount: r.bufferedAmount,
    bufferedAmountLowThreshold: r.bufferedAmountLowThreshold,
    id: r.id,
    label: r.label,
    maxPacketLifeTime: r.maxPacketLifeTime,
    maxRetransmits: r.maxRetransmits,
    negotiated: r.negotiated,
    ordered: r.ordered,
    protocol: r.protocol,
    readyState: r.readyState,
    // @ts-ignore w3c 仕様には存在しない property
    reliable: r.reliable
  };
}
function p(r, e, t, i, n) {
  const o = new Event(r);
  try {
    o.data = JSON.parse(JSON.stringify(e));
  } catch {
    o.data = e;
  }
  return o.logType = t, o.dataChannelId = i, o.dataChannelLabel = n, o;
}
function he(r, e) {
  const t = new Event("message");
  return t.label = r, t.data = e, t;
}
function de(r) {
  const e = new Event("datachannel");
  return e.datachannel = r, e;
}
async function S(r, e) {
  if (e) {
    const t = await I(new Uint8Array(r));
    return new TextDecoder().decode(t);
  }
  return r;
}
const f = async (r) => {
  const t = new Blob([r]).stream().pipeThrough(new CompressionStream("deflate"));
  return await new Response(t).arrayBuffer();
}, I = async (r) => {
  const t = new Blob([r]).stream().pipeThrough(new DecompressionStream("deflate"));
  return await new Response(t).arrayBuffer();
};
function ge(r) {
  const e = r.match(/^(v=.+?)(m=audio.+)/ms);
  if (e === null)
    return r;
  const t = e[1], i = [];
  let n = [];
  for (const a of e[2].split(/\n/))
    a[0] === "m" ? (n = [a], i.push(n)) : n.push(a);
  const s = i.map((a) => a.join(`
`)).map((a) => !ue(a) || !fe(a) || !me(a) || !pe(a) || !Se(a) ? a : Ce(a));
  return `${t}${s.join(`
`)}`;
}
function ue(r) {
  return /^m=audio/.test(r);
}
function fe(r) {
  return /a=setup:active/.test(r);
}
function me(r) {
  return /a=recvonly/.test(r);
}
function pe(r) {
  return /a=rtpmap:\d+\sopus/.test(r);
}
function Se(r) {
  return /a=fmtp:\d+/.test(r);
}
function Ce(r) {
  return r.replace(
    /(?<!stereo=1;.*)minptime=\d+(?!.*stereo=1)/,
    (e) => `${e};stereo=1`
  );
}
class w {
  constructor(e, t, i, n, o, s) {
    this.role = t, this.channelId = i, this.metadata = n, this.signalingUrlCandidates = e, this.options = o, this.connectionTimeout = 6e4, typeof this.options.timeout == "number" && (console.warn(
      "@deprecated timeout option will be removed in a future version. Use connectionTimeout."
    ), this.connectionTimeout = this.options.timeout), typeof this.options.connectionTimeout == "number" && (this.connectionTimeout = this.options.connectionTimeout), this.disconnectWaitTimeout = 3e3, typeof this.options.disconnectWaitTimeout == "number" && (this.disconnectWaitTimeout = this.options.disconnectWaitTimeout), this.signalingCandidateTimeout = 3e3, typeof this.options.signalingCandidateTimeout == "number" && (this.signalingCandidateTimeout = this.options.signalingCandidateTimeout), this.constraints = null, this.debug = s, this.simulcast = !1, this.spotlight = !1, this.sessionId = null, this.clientId = null, this.bundleId = null, this.connectionId = null, this.remoteConnectionIds = [], this.stream = null, this.ws = null, this.pc = null, this.encodings = [], this.callbacks = {
      disconnect: () => {
      },
      push: () => {
      },
      track: () => {
      },
      removetrack: () => {
      },
      notify: () => {
      },
      log: () => {
      },
      timeout: () => {
      },
      timeline: () => {
      },
      signaling: () => {
      },
      message: () => {
      },
      datachannel: () => {
      }
    }, this.authMetadata = null, this.connectionTimeoutTimerId = 0, this.monitorSignalingWebSocketEventTimerId = 0, this.monitorIceConnectionStateChangeTimerId = 0, this.soraDataChannels = {}, this.mids = {
      audio: "",
      video: ""
    }, this.signalingSwitched = !1, this.signalingOfferMessageDataChannels = {}, this.connectedSignalingUrl = "", this.contactSignalingUrl = "";
  }
  /**
   * SendRecv Object で発火するイベントのコールバックを設定するメソッド
   *
   * @example
   * ```
   * const sendrecv = connection.sendrecv("sora");
   * sendrecv.on("track", (event) => {
   *   // callback 処理
   * });
   * ```
   *
   * @param kind - イベントの種類(disconnect, push, track, removetrack, notify, log, timeout, timeline, signaling, message, datachannel)
   * @param callback - コールバック関数
   *
   * @public
   */
  on(e, t) {
    e in this.callbacks && (this.callbacks[e] = t);
  }
  /**
   * audio track を削除するメソッド
   *
   * @deprecated この関数は非推奨です。代わりに removeAudioTrack を使用してください
   *
   * @example
   * ```
   * const sendrecv = connection.sendrecv("sora");
   * const mediaStream = await navigator.mediaDevices.getUserMedia({audio: true, video: true});
   * await sendrecv.connect(mediaStream);
   *
   * sendrecv.stopAudioTrack(mediaStream);
   * ```
   *
   * @remarks
   * stream の audio track を停止後、PeerConnection の senders から対象の sender を削除します
   *
   * @param stream - audio track を削除する MediaStream
   *
   * @public
   */
  stopAudioTrack(e) {
    return console.warn(
      // @deprecated message
      "@deprecated stopAudioTrack will be removed in a future version. Use removeAudioTrack instead."
    ), this.removeAudioTrack(e);
  }
  /**
   * audio track を削除するメソッド
   *
   * @example
   * ```
   * const sendrecv = connection.sendrecv("sora");
   * const mediaStream = await navigator.mediaDevices.getUserMedia({audio: true, video: true});
   * await sendrecv.connect(mediaStream);
   *
   * sendrecv.removeAudioTrack(mediaStream);
   * ```
   *
   * @remarks
   * stream の audio track を停止後、PeerConnection の senders から対象の sender を削除します
   *
   * @param stream - audio track を削除する MediaStream
   *
   * @public
   */
  removeAudioTrack(e) {
    for (const t of e.getAudioTracks())
      t.enabled = !1;
    return new Promise((t, i) => {
      setTimeout(() => {
        const n = e.getAudioTracks().map(async (o) => {
          if (o.stop(), e.removeTrack(o), this.pc !== null) {
            const s = this.pc.getSenders().find((a) => a.track && a.track.id === o.id);
            if (s)
              return s.replaceTrack(null);
          }
        });
        Promise.all(n).then(() => t()).catch(i);
      }, 100);
    });
  }
  /**
   * video track を削除するメソッド
   *
   * @deprecated この関数は非推奨です。代わりに removeVideoTrack を使用してください
   *
   * @example
   * ```
   * const sendrecv = connection.sendrecv("sora");
   * const mediaStream = await navigator.mediaDevices.getUserMedia({audio: true, video: true});
   * await sendrecv.connect(mediaStream);
   *
   * sendrecv.stopVideoTrack(mediaStream);
   * ```
   *
   * @remarks
   * stream の video track を停止後、PeerConnection の senders から対象の sender を削除します
   *
   * @param stream - video track を停止する MediaStream
   *
   * @public
   */
  stopVideoTrack(e) {
    return console.warn(
      // @deprecated message
      "@deprecated stopVideoTrack will be removed in a future version. Use removeVideoTrack instead."
    ), this.removeVideoTrack(e);
  }
  /**
   * video track を削除するメソッド
   *
   * @example
   * ```
   * const sendrecv = connection.sendrecv("sora");
   * const mediaStream = await navigator.mediaDevices.getUserMedia({audio: true, video: true});
   * await sendrecv.connect(mediaStream);
   *
   * sendrecv.removeVideoTrack(mediaStream);
   * ```
   *
   * @remarks
   * stream の video track を停止後、PeerConnection の senders から対象の sender を削除します
   *
   * @param stream - video track を削除する MediaStream
   *
   * @public
   */
  removeVideoTrack(e) {
    for (const t of e.getVideoTracks())
      t.enabled = !1;
    return new Promise((t, i) => {
      setTimeout(() => {
        const n = e.getVideoTracks().map(async (o) => {
          if (o.stop(), e.removeTrack(o), this.pc !== null) {
            const s = this.pc.getSenders().find((a) => a.track && a.track.id === o.id);
            if (s)
              return s.replaceTrack(null);
          }
        });
        Promise.all(n).then(() => t()).catch(i);
      }, 100);
    });
  }
  /**
   * audio track を入れ替えするメソッド
   *
   * @example
   * ```
   * const sendrecv = connection.sendrecv("sora");
   * const mediaStream = await navigator.mediaDevices.getUserMedia({audio: true, video: true});
   * await sendrecv.connect(mediaStream);
   *
   * const replacedMediaStream = await navigator.mediaDevices.getUserMedia({audio: true});
   * await sendrecv.replaceAudioTrack(mediaStream, replacedMediaStream.getAudioTracks()[0]);
   * ```
   *
   * @remarks
   * stream の audio track を停止後、新しい audio track をセットします
   *
   * @param stream - audio track を削除する MediaStream
   * @param audioTrack - 新しい audio track
   *
   * @public
   */
  async replaceAudioTrack(e, t) {
    await this.removeAudioTrack(e);
    const i = this.getAudioTransceiver();
    if (i === null)
      throw new Error("Unable to set an audio track. Audio track sender is undefined");
    e.addTrack(t), await i.sender.replaceTrack(t);
  }
  /**
   * video track を入れ替えするメソッド
   *
   * @example
   * ```
   * const sendrecv = connection.sendrecv("sora");
   * const mediaStream = await navigator.mediaDevices.getUserMedia({audio: true, video: true});
   * await sendrecv.connect(mediaStream);
   *
   * const replacedMediaStream = await navigator.mediaDevices.getUserMedia({video: true});
   * await sendrecv.replaceVideoTrack(mediaStream, replacedMediaStream.getVideoTracks()[0]);
   * ```
   *
   * @remarks
   * stream の video track を停止後、新しい video track をセットします
   *
   * @param stream - video track を削除する MediaStream
   * @param videoTrack - 新しい video track
   *
   * @public
   */
  async replaceVideoTrack(e, t) {
    await this.removeVideoTrack(e);
    const i = this.getVideoTransceiver();
    if (i === null)
      throw new Error("Unable to set video track. Video track sender is undefined");
    e.addTrack(t), await i.sender.replaceTrack(t);
  }
  /**
   * connect 処理中に例外が発生した場合の切断処理をするメソッド
   */
  signalingTerminate() {
    for (const e of Object.keys(this.soraDataChannels)) {
      const t = this.soraDataChannels[e];
      t && t.close(), delete this.soraDataChannels[e];
    }
    this.ws && (this.ws.close(), this.ws = null), this.pc && this.pc.close(), this.initializeConnection();
  }
  /**
   * PeerConnection の state に異常が発生した場合の切断処理をするメソッド
   *
   * @param title - disconnect callback に渡すイベントのタイトル
   */
  abendPeerConnectionState(e) {
    this.clearMonitorIceConnectionStateChange(), this.pc && (this.pc.ondatachannel = null, this.pc.oniceconnectionstatechange = null, this.pc.onicegatheringstatechange = null, this.pc.onconnectionstatechange = null), this.ws && (this.ws.onclose = (i) => {
      this.writeWebSocketTimelineLog("onclose", {
        code: i.code,
        reason: i.reason
      });
    }, this.ws.onmessage = null, this.ws.onerror = null);
    for (const i of Object.keys(this.soraDataChannels)) {
      const n = this.soraDataChannels[i];
      n && (n.onclose = (o) => {
        const s = o.currentTarget;
        this.writeDataChannelTimelineLog("onclose", s), this.trace("CLOSE DATA CHANNEL", s.label);
      }, n.onmessage = null, n.onerror = null);
    }
    for (const i of Object.keys(this.soraDataChannels)) {
      const n = this.soraDataChannels[i];
      n && n.close(), delete this.soraDataChannels[i];
    }
    this.ws && (this.ws.close(), this.ws = null), this.pc && this.pc.close(), this.initializeConnection();
    const t = this.soraCloseEvent("abend", e);
    this.callbacks.disconnect(t), this.writeSoraTimelineLog("disconnect-abend", t);
  }
  /**
   * WebSocket が Sora 側から正常に切断されたり、
   * DataChannel 経由で Type: close のメッセージを受信した場合の処理
   * ライフタイムで切れたり、 切断系の API 切られたりした場合に呼ばれる
   *
   * @param params - 切断時の状況を入れる Record
   */
  shutdown(e) {
    this.clearMonitorIceConnectionStateChange(), this.pc && (this.pc.ondatachannel = null, this.pc.oniceconnectionstatechange = null, this.pc.onicegatheringstatechange = null, this.pc.onconnectionstatechange = null);
    for (const i of Object.keys(this.soraDataChannels)) {
      const n = this.soraDataChannels[i];
      n && (n.onclose = (o) => {
        const s = o.currentTarget;
        this.writeDataChannelTimelineLog("onclose", s), this.trace("CLOSE DATA CHANNEL", s.label);
      }, n.onmessage = null, n.onerror = null, n.close()), delete this.soraDataChannels[i];
    }
    this.maybeClosePeerConnection(), this.initializeConnection();
    const t = this.soraCloseEvent("normal", "SHUTDOWN", e);
    this.writeSoraTimelineLog("disconnect-normal", t), this.callbacks.disconnect(t);
  }
  /**
   * 何かしらの異常があった場合の切断処理
   *
   * @param title - disconnect callback に渡すイベントのタイトル
   * @param params - 切断時の状況を入れる Record
   */
  async abend(e, t) {
    this.clearMonitorIceConnectionStateChange(), this.pc && (this.pc.ondatachannel = null, this.pc.oniceconnectionstatechange = null, this.pc.onicegatheringstatechange = null, this.pc.onconnectionstatechange = null), this.ws && (this.ws.onclose = (n) => {
      this.writeWebSocketTimelineLog("onclose", {
        code: n.code,
        reason: n.reason
      });
    }, this.ws.onmessage = null, this.ws.onerror = null);
    for (const n of Object.keys(this.soraDataChannels)) {
      const o = this.soraDataChannels[n];
      o && (o.onclose = (s) => {
        const a = s.currentTarget;
        this.writeDataChannelTimelineLog("onclose", a), this.trace("CLOSE DATA CHANNEL", a.label);
      }, o.onmessage = null, o.onerror = null);
    }
    if (this.soraDataChannels.signaling) {
      const n = { type: C, reason: e };
      if (this.signalingOfferMessageDataChannels.signaling && this.signalingOfferMessageDataChannels.signaling.compress === !0) {
        const o = new TextEncoder().encode(JSON.stringify(n)), s = await f(o);
        if (this.soraDataChannels.signaling.readyState === "open")
          try {
            this.soraDataChannels.signaling.send(s), this.writeDataChannelSignalingLog(
              "send-disconnect",
              this.soraDataChannels.signaling,
              n
            );
          } catch (a) {
            const c = a.message;
            this.writeDataChannelSignalingLog(
              "failed-to-send-disconnect",
              this.soraDataChannels.signaling,
              c
            );
          }
      } else if (this.soraDataChannels.signaling.readyState === "open")
        try {
          this.soraDataChannels.signaling.send(JSON.stringify(n)), this.writeDataChannelSignalingLog(
            "send-disconnect",
            this.soraDataChannels.signaling,
            n
          );
        } catch (o) {
          const s = o.message;
          this.writeDataChannelSignalingLog(
            "failed-to-send-disconnect",
            this.soraDataChannels.signaling,
            s
          );
        }
    }
    for (const n of Object.keys(this.soraDataChannels)) {
      const o = this.soraDataChannels[n];
      o && (o.onerror = null, o.close()), delete this.soraDataChannels[n];
    }
    if (await this.disconnectWebSocket(e), this.maybeClosePeerConnection(), this.initializeConnection(), e === "WEBSOCKET-ONCLOSE" && t && (t.code === 1e3 || t.code === 1005)) {
      const n = this.soraCloseEvent("normal", "DISCONNECT", t);
      this.writeSoraTimelineLog("disconnect-normal", n), this.callbacks.disconnect(n);
      return;
    }
    const i = this.soraCloseEvent("abend", e, t);
    this.writeSoraTimelineLog("disconnect-abend", i), this.callbacks.disconnect(this.soraCloseEvent("abend", e, t));
  }
  /**
   * 接続状態の初期化をするメソッド
   */
  initializeConnection() {
    this.simulcast = !1, this.spotlight = !1, this.sessionId = null, this.clientId = null, this.bundleId = null, this.connectionId = null, this.remoteConnectionIds = [], this.stream = null, this.ws = null, this.pc = null, this.encodings = [], this.authMetadata = null, this.soraDataChannels = {}, this.mids = {
      audio: "",
      video: ""
    }, this.signalingSwitched = !1, this.signalingOfferMessageDataChannels = {}, this.contactSignalingUrl = "", this.connectedSignalingUrl = "", this.clearConnectionTimeout();
  }
  /**
   * WebSocket を切断するメソッド
   *
   * @remarks
   * 正常/異常どちらの切断でも使用する
   *
   * @param title - type disconnect 時の reason
   */
  disconnectWebSocket(e) {
    let t = 0;
    return this.signalingSwitched ? (this.ws && (this.ws.close(), this.ws = null), Promise.resolve(null)) : new Promise((i, n) => {
      if (!this.ws)
        return i(null);
      if (this.ws.onclose = (o) => (this.ws && (this.ws.close(), this.ws = null), clearTimeout(t), this.writeWebSocketTimelineLog("onclose", {
        code: o.code,
        reason: o.reason
      }), i({ code: o.code, reason: o.reason })), this.ws.readyState === 1) {
        const o = { type: C, reason: e };
        this.ws.send(JSON.stringify(o)), this.writeWebSocketSignalingLog("send-disconnect", o), t = setTimeout(() => {
          this.ws && (this.ws.close(), this.ws = null), i({ code: 1006, reason: "" });
        }, this.disconnectWaitTimeout);
      } else
        return this.ws.close(), this.ws = null, i(null);
    });
  }
  // DataChannel の強制終了処理
  forceCloseDataChannels() {
    for (const e of Object.keys(this.soraDataChannels)) {
      const t = this.soraDataChannels[e];
      t && (t.onerror = null, t.onclose = null, t.onmessage = null, t.close());
    }
  }
  /**
   * DataChannel を切断するメソッド
   *
   * @remarks
   * 正常/異常どちらの切断でも使用する
   */
  async disconnectDataChannel() {
    if (!this.soraDataChannels.signaling)
      return this.forceCloseDataChannels(), { code: 4999, reason: new Z().message };
    const e = new Promise((o, s) => {
      setTimeout(() => s(new X()), this.disconnectWaitTimeout);
    }), t = [];
    for (const o of Object.keys(this.soraDataChannels)) {
      const s = this.soraDataChannels[o];
      s && t.push(
        new Promise((a, c) => {
          s.onclose = (d) => {
            const u = d.currentTarget;
            this.writeDataChannelTimelineLog("onclose", u), this.trace("CLOSE DATA CHANNEL", u.label), a();
          }, s.onerror = () => c(new ee());
        })
      );
    }
    const i = Promise.all(t), n = { type: C, reason: "NO-ERROR" };
    if (this.signalingOfferMessageDataChannels.signaling && this.signalingOfferMessageDataChannels.signaling.compress === !0) {
      const o = new TextEncoder().encode(JSON.stringify(n)), s = await f(o);
      if (this.soraDataChannels.signaling?.readyState && this.soraDataChannels.signaling.readyState === "open")
        try {
          this.soraDataChannels.signaling.send(s), this.writeDataChannelSignalingLog(
            "send-disconnect",
            this.soraDataChannels.signaling,
            n
          );
        } catch (a) {
          const c = a.message;
          this.writeDataChannelSignalingLog(
            "failed-to-send-disconnect",
            this.soraDataChannels.signaling,
            c
          );
        }
    } else if (this.soraDataChannels.signaling.readyState === "open")
      try {
        this.soraDataChannels.signaling.send(JSON.stringify(n)), this.writeDataChannelSignalingLog(
          "send-disconnect",
          this.soraDataChannels.signaling,
          n
        );
      } catch (o) {
        const s = o.message;
        this.writeDataChannelSignalingLog(
          "failed-to-send-disconnect",
          this.soraDataChannels.signaling,
          s
        );
      }
    try {
      return await Promise.race([e, i]), { code: 1e3, reason: "TYPE-DISCONNECT" };
    } catch (o) {
      return this.forceCloseDataChannels(), { code: 4999, reason: o.message };
    }
  }
  /**
   * もし PeerConnection の状態が closed でなければ PeerConnection を閉じる
   *
   * @remarks
   * 正常/異常どちらの切断でも使用する
   */
  maybeClosePeerConnection() {
    this.pc && this.pc.connectionState !== "closed" && this.pc.close();
  }
  /**
   * 切断処理をするメソッド
   *
   * @example
   * ```
   * await sendrecv.disconnect();
   * ```
   *
   * @public
   */
  async disconnect() {
    this.clearMonitorIceConnectionStateChange(), this.pc && (this.pc.ondatachannel = null, this.pc.oniceconnectionstatechange = null, this.pc.onicegatheringstatechange = null, this.pc.onconnectionstatechange = null), this.ws && (this.ws.onclose = (t) => {
      this.writeWebSocketTimelineLog("onclose", {
        code: t.code,
        reason: t.reason
      });
    }, this.ws.onmessage = null, this.ws.onerror = null);
    let e = null;
    if (this.signalingSwitched) {
      const t = await this.disconnectDataChannel();
      t.code === 4999 && (e = this.soraCloseEvent("abend", t.reason)), e = this.soraCloseEvent("normal", "DISCONNECT", t), await this.disconnectWebSocket("NO-ERROR"), this.maybeClosePeerConnection();
    } else {
      const t = await this.disconnectWebSocket("NO-ERROR");
      this.maybeClosePeerConnection(), this.forceCloseDataChannels(), t !== null && (e = this.soraCloseEvent("normal", "DISCONNECT", t));
    }
    this.initializeConnection(), e && (e.type === "abend" ? this.writeSoraTimelineLog("disconnect-abend", e) : e.type === "normal" && this.writeSoraTimelineLog("disconnect-normal", e), this.callbacks.disconnect(e));
  }
  /**
   * シグナリングに使う WebSocket インスタンスを作成するメソッド
   *
   * @remarks
   * シグナリング候補の URL 一覧に順に接続します
   *
   * 接続できた URL がない場合は例外が発生します
   *
   * @param signalingUrlCandidates - シグナリング候補の URL. 後方互換のため string | string[] を受け取る
   *
   * @returns
   * 接続できた WebSocket インスタンスを返します
   */
  async getSignalingWebSocket(e) {
    if (typeof e == "string") {
      const t = e;
      return new Promise((i, n) => {
        const o = new WebSocket(t);
        o.onclose = (s) => {
          const a = new g(
            `Signaling failed. CloseEventCode:${s.code} CloseEventReason:'${s.reason}'`
          );
          a.code = s.code, a.reason = s.reason, this.writeWebSocketTimelineLog("onclose", a), n(a);
        }, o.onopen = (s) => {
          i(o);
        };
      });
    }
    if (Array.isArray(e)) {
      let t = !1;
      const i = (n) => new Promise((o, s) => {
        const a = new WebSocket(n), c = setTimeout(() => {
          this.writeWebSocketSignalingLog("signaling-url-candidate", {
            type: "timeout",
            url: a.url
          }), a && !t && (a.onclose = null, a.onerror = null, a.onopen = null, a.close(), s());
        }, this.signalingCandidateTimeout);
        a.onclose = (d) => {
          this.writeWebSocketSignalingLog("signaling-url-candidate", {
            type: "close",
            url: a.url,
            message: "WebSocket closed",
            code: d.code,
            reason: d.reason
          }), a && a.close(), clearInterval(c), s();
        }, a.onerror = (d) => {
          this.writeWebSocketSignalingLog("signaling-url-candidate", {
            type: "error",
            url: a.url,
            message: "Failed to connect WebSocket"
          }), a && (a.onclose = null, a.close()), clearInterval(c), s();
        }, a.onopen = (d) => {
          a && (clearInterval(c), t ? (this.writeWebSocketSignalingLog("signaling-url-candidate", {
            type: "open",
            url: a.url,
            selected: !1
          }), a.onerror = null, a.onclose = null, a.onopen = null, a.close(), s()) : (this.writeWebSocketSignalingLog("signaling-url-candidate", {
            type: "open",
            url: a.url,
            selected: !0
          }), a.onerror = null, a.onclose = null, a.onopen = null, t = !0, o(a)));
        };
      });
      try {
        return await Promise.any(
          e.map((n) => i(n))
        );
      } catch {
        throw new g("Signaling failed. All signaling URL candidates failed to connect");
      }
    }
    throw new g("Signaling failed. Invalid format signaling URL candidates");
  }
  /**
   * シグナリング処理を行うメソッド
   *
   * @remarks
   * シグナリング候補の URL 一覧に順に接続します
   *
   * 接続できた URL がない場合は例外が発生します
   *
   * @param ws - WebSocket インスタンス
   * @param redirect - クラスター接続時にリダイレクトされた場合のフラグ
   *
   * @returns
   * Sora から受け取った type offer メッセージを返します
   */
  async signaling(e, t = !1) {
    const i = await this.createOffer();
    return this.trace("CREATE OFFER", i), new Promise((n, o) => {
      this.writeWebSocketSignalingLog("new-websocket", e.url), e.binaryType = "arraybuffer", e.onclose = (s) => {
        const a = new g(
          `Signaling failed. CloseEventCode:${s.code} CloseEventReason:'${s.reason}'`
        );
        a.code = s.code, a.reason = s.reason, this.writeWebSocketTimelineLog("onclose", a), this.signalingTerminate(), o(a);
      }, e.onmessage = async (s) => {
        if (typeof s.data != "string")
          throw new Error("Received invalid signaling data");
        const a = JSON.parse(s.data);
        if (a.type === b)
          this.writeWebSocketSignalingLog("onmessage-offer", a), this.signalingOnMessageTypeOffer(a), this.connectedSignalingUrl = e.url, n(a);
        else if (a.type === A)
          this.writeWebSocketSignalingLog("onmessage-update", a), await this.signalingOnMessageTypeUpdate(a);
        else if (a.type === O)
          this.writeWebSocketSignalingLog("onmessage-re-offer", a), await this.signalingOnMessageTypeReOffer(a);
        else if (a.type === F)
          await this.signalingOnMessageTypePing(a);
        else if (a.type === j)
          this.callbacks.push(a, m);
        else if (a.type === Y)
          a.event_type === "connection.created" ? this.writeWebSocketTimelineLog("notify-connection.created", a) : a.event_type === "connection.destroyed" && this.writeWebSocketTimelineLog("notify-connection.destroyed", a), this.signalingOnMessageTypeNotify(a, m);
        else if (a.type === U)
          this.writeWebSocketSignalingLog("onmessage-switched", a), this.signalingOnMessageTypeSwitched(a);
        else if (a.type === G) {
          this.writeWebSocketSignalingLog("onmessage-redirect", a);
          try {
            const c = await this.signalingOnMessageTypeRedirect(a);
            n(c);
          } catch (c) {
            o(c);
          }
        }
      }, (async () => {
        let s;
        try {
          s = oe(
            i.sdp || "",
            this.role,
            this.channelId,
            this.metadata,
            this.options,
            t
          );
        } catch (a) {
          o(a);
          return;
        }
        this.trace("SIGNALING CONNECT MESSAGE", s), e && (e.send(JSON.stringify(s)), this.writeWebSocketSignalingLog(`send-${s.type}`, s), this.ws = e, t || (this.contactSignalingUrl = e.url, this.writeWebSocketSignalingLog("contact-signaling-url", this.contactSignalingUrl)));
      })();
    });
  }
  /**
   * PeerConnection 接続処理をするメソッド
   *
   * @param message - シグナリング処理で受け取った type offer メッセージ
   */
  async connectPeerConnection(e) {
    let t = Object.assign({}, e.config);
    if (window.RTCPeerConnection.generateCertificate !== void 0) {
      const i = await window.RTCPeerConnection.generateCertificate({
        name: "ECDSA",
        namedCurve: "P-256"
      });
      t = Object.assign({ certificates: [i] }, t);
    }
    this.trace("PEER CONNECTION CONFIG", t), this.writePeerConnectionTimelineLog("new-peerconnection", t), this.pc = new window.RTCPeerConnection(t, this.constraints), this.pc.oniceconnectionstatechange = (i) => {
      this.pc && (this.writePeerConnectionTimelineLog("oniceconnectionstatechange", {
        connectionState: this.pc.connectionState,
        iceConnectionState: this.pc.iceConnectionState,
        iceGatheringState: this.pc.iceGatheringState
      }), this.trace("ONICECONNECTIONSTATECHANGE ICECONNECTIONSTATE", this.pc.iceConnectionState));
    }, this.pc.onicegatheringstatechange = (i) => {
      this.pc && this.writePeerConnectionTimelineLog("onicegatheringstatechange", {
        connectionState: this.pc.connectionState,
        iceConnectionState: this.pc.iceConnectionState,
        iceGatheringState: this.pc.iceGatheringState
      });
    }, this.pc.onconnectionstatechange = (i) => {
      this.pc && this.writePeerConnectionTimelineLog("onconnectionstatechange", {
        connectionState: this.pc.connectionState,
        iceConnectionState: this.pc.iceConnectionState,
        iceGatheringState: this.pc.iceGatheringState
      });
    }, this.pc.ondatachannel = (i) => {
      this.onDataChannel(i);
    };
  }
  /**
   * setRemoteDescription 処理を行うメソッド
   *
   * @param message - シグナリング処理で受け取った type offer | type update | type re-offer メッセージ
   */
  async setRemoteDescription(e) {
    if (!this.pc)
      return;
    const t = this.processOfferSdp(e.sdp), i = new RTCSessionDescription({
      type: b,
      sdp: t
    });
    await this.pc.setRemoteDescription(i), this.writePeerConnectionTimelineLog("set-remote-description", i);
  }
  /**
   * createAnswer 処理を行うメソッド
   *
   * @remarks
   * サイマルキャスト用の setParameters 処理もここで行う
   *
   * @param message - シグナリング処理で受け取った type offer | type update | type re-offer メッセージ
   */
  async createAnswer(e) {
    if (!this.pc)
      return;
    for (const i of Object.values(this.mids)) {
      const n = this.pc.getTransceivers().find((o) => o.mid === i);
      n && n.direction === M && (n.direction = y);
    }
    if (this.simulcast && (this.role === y || this.role === E)) {
      const i = this.pc.getTransceivers().find((n) => {
        if (n.mid !== null && n.sender.track !== null && !(n.currentDirection !== null && n.currentDirection !== E) && (this.mids.video !== "" && this.mids.video === n.mid || 0 <= n.mid.indexOf("video")))
          return n;
      });
      if (i) {
        await this.setSenderParameters(i, this.encodings), await this.setRemoteDescription(e), this.trace("TRANSCEIVER SENDER GET_PARAMETERS", i.sender.getParameters()), await this.setSenderParameters(i, this.encodings);
        const n = await this.pc.createAnswer();
        await this.pc.setLocalDescription(n), this.trace("TRANSCEIVER SENDER GET_PARAMETERS", i.sender.getParameters());
        return;
      }
    }
    const t = await this.pc.createAnswer();
    this.writePeerConnectionTimelineLog("create-answer", t), this.options.forceStereoOutput && t.sdp && (t.sdp = ge(t.sdp)), await this.pc.setLocalDescription(t), this.writePeerConnectionTimelineLog("set-local-description", t);
  }
  /**
   * カスタムコーデック対応用に offer SDP を処理するメソッド
   *
   * @param sdp offer SDP
   * @returns 処理後の SDP
   */
  processOfferSdp(e) {
    let t = e;
    return ae() && (t = t.replace(/^m=(audio|video) 0 /gm, (i, n) => `m=${n} 9 `)), t;
  }
  /**
   * シグナリングサーバーに type answer を投げるメソッド
   */
  sendAnswer() {
    if (this.pc && this.ws && this.pc.localDescription) {
      this.trace("ANSWER SDP", this.pc.localDescription.sdp);
      const e = this.pc.localDescription.sdp, t = { type: W, sdp: e };
      this.ws.send(JSON.stringify(t)), this.writeWebSocketSignalingLog("send-answer", t);
    }
  }
  /**
   * iceCandidate 処理をするメソッド
   */
  onIceCandidate() {
    return new Promise((e, t) => {
      this.pc && (this.pc.oniceconnectionstatechange = (i) => {
        this.pc && (this.writePeerConnectionTimelineLog("oniceconnectionstatechange", {
          connectionState: this.pc.connectionState,
          iceConnectionState: this.pc.iceConnectionState,
          iceGatheringState: this.pc.iceGatheringState
        }), this.trace("ONICECONNECTIONSTATECHANGE ICECONNECTIONSTATE", this.pc.iceConnectionState), this.pc.iceConnectionState === "connected" && e());
      }, this.pc.onicecandidate = async (i) => {
        if (this.writePeerConnectionTimelineLog("onicecandidate", i.candidate), this.pc && this.trace("ONICECANDIDATE ICEGATHERINGSTATE", this.pc.iceGatheringState), i.candidate === null)
          e();
        else {
          const n = i.candidate.toJSON(), o = Object.assign(n, {
            type: x
          });
          this.trace("ONICECANDIDATE CANDIDATE MESSAGE", o), await this.sendSignalingMessage(o);
        }
      });
    });
  }
  /**
   * connectionState が "connected" になるのを監視するメソッド
   *
   * @remarks
   * PeerConnection.connectionState が実装されていない場合は何もしない
   */
  waitChangeConnectionStateConnected() {
    return new Promise((e, t) => {
      if (this.pc && this.pc.connectionState === void 0) {
        e();
        return;
      }
      const i = setInterval(() => {
        if (this.pc)
          this.pc && this.pc.connectionState === "connected" && (clearInterval(i), e());
        else {
          const n = new Error();
          n.message = "PeerConnection connectionState did not change to 'connected'", clearInterval(i), t(n);
        }
      }, 10);
    });
  }
  /**
   * 初回シグナリング接続時の WebSocket の切断を監視するメソッド
   *
   * @remarks
   * 意図しない切断があった場合には異常終了処理を実行する
   */
  monitorSignalingWebSocketEvent() {
    return new Promise((e, t) => {
      this.monitorSignalingWebSocketEventTimerId = setInterval(() => {
        this.ws && (this.clearMonitorSignalingWebSocketEvent(), this.ws.onclose = (i) => {
          const n = new g(
            `Signaling failed. CloseEventCode:${i.code} CloseEventReason:'${i.reason}'`
          );
          n.code = i.code, n.reason = i.reason, this.writeWebSocketTimelineLog("onclose", n), this.signalingTerminate(), t(n);
        }, this.ws.onerror = (i) => {
          const n = new g("Signaling failed. WebSocket onerror was called");
          this.writeWebSocketSignalingLog("onerror", n), this.signalingTerminate(), t(n);
        });
      }, 100);
    });
  }
  /**
   * WebSocket の切断を監視するメソッド
   *
   * @remarks
   * WebSocket のクローズコードが 1000 の場合は正常終了処理を実行する
   * 意図しない切断があった場合には異常終了処理を実行する
   */
  monitorWebSocketEvent() {
    this.ws && (this.ws.onclose = async (e) => {
      this.writeWebSocketTimelineLog("onclose", {
        code: e.code,
        reason: e.reason
      }), e.code === 1e3 ? this.shutdown({
        code: e.code,
        reason: e.reason
      }) : await this.abend("WEBSOCKET-ONCLOSE", {
        code: e.code,
        reason: e.reason
      });
    }, this.ws.onerror = async (e) => {
      this.writeWebSocketSignalingLog("onerror"), await this.abend("WEBSOCKET-ONERROR");
    });
  }
  /**
   * 初回シグナリング後 PeerConnection の state を監視するメソッド
   *
   * @remarks
   * connectionState, iceConnectionState を監視して不正な場合に切断する
   */
  monitorPeerConnectionState() {
    this.pc && (this.pc.oniceconnectionstatechange = (e) => {
      this.pc && this.pc.connectionState === void 0 && (this.writePeerConnectionTimelineLog("oniceconnectionstatechange", {
        connectionState: this.pc.connectionState,
        iceConnectionState: this.pc.iceConnectionState,
        iceGatheringState: this.pc.iceGatheringState
      }), this.trace("ONICECONNECTIONSTATECHANGE ICECONNECTIONSTATE", this.pc.iceConnectionState), clearTimeout(this.monitorIceConnectionStateChangeTimerId), this.pc.iceConnectionState === "failed" ? this.abendPeerConnectionState("ICE-CONNECTION-STATE-FAILED") : this.pc.iceConnectionState === "disconnected" && (this.monitorIceConnectionStateChangeTimerId = setTimeout(() => {
        this.pc && this.pc.iceConnectionState === "disconnected" && this.abendPeerConnectionState("ICE-CONNECTION-STATE-DISCONNECTED-TIMEOUT");
      }, 1e4)));
    }, this.pc.onconnectionstatechange = (e) => {
      this.pc && (this.writePeerConnectionTimelineLog("onconnectionstatechange", {
        connectionState: this.pc.connectionState,
        iceConnectionState: this.pc.iceConnectionState,
        iceGatheringState: this.pc.iceGatheringState
      }), this.pc.connectionState === "failed" && this.abendPeerConnectionState("CONNECTION-STATE-FAILED"));
    });
  }
  /**
   * 初回シグナリングの接続タイムアウト処理をするメソッド
   */
  setConnectionTimeout() {
    return new Promise((e, t) => {
      0 < this.connectionTimeout && (this.connectionTimeoutTimerId = setTimeout(() => {
        if (!this.pc || this.pc && this.pc.connectionState !== void 0 && this.pc.connectionState !== "connected") {
          const i = new Error();
          i.message = "Signaling connection timeout", this.callbacks.timeout(), this.trace("DISCONNECT", "Signaling connection timeout"), this.writePeerConnectionTimelineLog("signaling-connection-timeout", {
            connectionTimeout: this.connectionTimeout
          }), this.signalingTerminate(), t(i);
        }
      }, this.connectionTimeout));
    });
  }
  /**
   * setConnectionTimeout でセットしたタイマーを止めるメソッド
   */
  clearConnectionTimeout() {
    clearTimeout(this.connectionTimeoutTimerId);
  }
  /**
   * monitorSignalingWebSocketEvent でセットしたタイマーを止めるメソッド
   */
  clearMonitorSignalingWebSocketEvent() {
    clearInterval(this.monitorSignalingWebSocketEventTimerId);
  }
  /**
   * monitorPeerConnectionState でセットしたタイマーを止めるメソッド
   */
  clearMonitorIceConnectionStateChange() {
    clearInterval(this.monitorIceConnectionStateChangeTimerId);
  }
  /**
   * trace log を出力するメソッド
   *
   * @param title - ログのタイトル
   * @param message - ログの本文
   */
  trace(e, t) {
    this.callbacks.log(e, t), this.debug && ce(this.clientId, e, t);
  }
  /**
   * WebSocket のシグナリングログ処理をするメソッド
   *
   * @param eventType - イベントタイプ
   * @param data - イベントデータ
   */
  writeWebSocketSignalingLog(e, t) {
    this.callbacks.signaling(N(e, t, m)), this.writeWebSocketTimelineLog(e, t);
  }
  /**
   * DataChannel のシグナリングログ処理をするメソッド
   *
   * @param eventType - イベントタイプ
   * @param data - イベントデータ
   */
  writeDataChannelSignalingLog(e, t, i) {
    this.callbacks.signaling(N(e, i, R)), this.writeDataChannelTimelineLog(e, t, i);
  }
  /**
   * WebSocket のタイムラインログ処理をするメソッド
   *
   * @param eventType - イベントタイプ
   * @param data - イベントデータ
   */
  writeWebSocketTimelineLog(e, t) {
    const i = p(e, t, m);
    this.callbacks.timeline(i);
  }
  /**
   * DataChannel のタイムラインログ処理をするメソッド
   *
   * @param eventType - イベントタイプ
   * @param data - イベントデータ
   */
  writeDataChannelTimelineLog(e, t, i) {
    const n = p(e, i, "datachannel", t.id, t.label);
    this.callbacks.timeline(n);
  }
  /**
   * PeerConnection のタイムラインログ処理をするメソッド
   *
   * @param eventType - イベントタイプ
   * @param data - イベントデータ
   */
  writePeerConnectionTimelineLog(e, t) {
    const i = p(e, t, "peerconnection");
    this.callbacks.timeline(i);
  }
  /**
   * Sora との接続のタイムラインログ処理をするメソッド
   *
   * @param eventType - イベントタイプ
   * @param data - イベントデータ
   */
  writeSoraTimelineLog(e, t) {
    const i = p(e, t, "sora");
    this.callbacks.timeline(i);
  }
  /**
   * createOffer 処理をするメソッド
   *
   * @returns
   * 生成した RTCSessionDescription を返します
   */
  async createOffer() {
    const e = { iceServers: [] }, t = new window.RTCPeerConnection(e);
    if (se()) {
      t.addTransceiver("video", { direction: "recvonly" }), t.addTransceiver("audio", { direction: "recvonly" });
      const n = await t.createOffer();
      return t.close(), this.writePeerConnectionTimelineLog("create-offer", n), n;
    }
    const i = await t.createOffer({
      offerToReceiveAudio: !0,
      offerToReceiveVideo: !0
    });
    return t.close(), this.writePeerConnectionTimelineLog("create-offer", i), i;
  }
  /**
   * シグナリングサーバーから受け取った type offer メッセージを処理をするメソッド
   *
   * @param message - type offer メッセージ
   */
  signalingOnMessageTypeOffer(e) {
    if (this.simulcast = e.simulcast, this.spotlight = e.spotlight, e.session_id !== void 0 && (this.sessionId = e.session_id), this.clientId = e.client_id, this.bundleId = e.bundle_id, this.connectionId = e.connection_id, e.metadata !== void 0 && (this.authMetadata = e.metadata), Array.isArray(e.encodings) && (this.encodings = e.encodings), e.mid !== void 0 && e.mid.audio !== void 0 && (this.mids.audio = e.mid.audio), e.mid !== void 0 && e.mid.video !== void 0 && (this.mids.video = e.mid.video), e.data_channels)
      for (const t of e.data_channels)
        this.signalingOfferMessageDataChannels[t.label] = t;
    this.trace("SIGNALING OFFER MESSAGE", e), this.trace("OFFER SDP", e.sdp);
  }
  /**
   * シグナリングサーバーに type update を投げるメソッド
   * @deprecated このメソッドは非推奨です。将来のバージョンで削除される可能性があります。
   */
  async sendUpdateAnswer() {
    this.pc && this.ws && this.pc.localDescription && (this.trace("UPDATE ANSWER SDP", this.pc.localDescription.sdp), await this.sendSignalingMessage({
      type: A,
      sdp: this.pc.localDescription.sdp
    }));
  }
  /**
   * シグナリングサーバーに type re-answer を投げるメソッド
   */
  async sendReAnswer() {
    this.pc?.localDescription && (this.trace("RE ANSWER SDP", this.pc.localDescription.sdp), await this.sendSignalingMessage({
      type: J,
      sdp: this.pc.localDescription.sdp
    }));
  }
  /**
   * シグナリングサーバーから受け取った type update メッセージを処理をするメソッド
   * @deprecated このメソッドは非推奨です。将来のバージョンで削除される可能性があります。
   * @param message - type update メッセージ
   */
  async signalingOnMessageTypeUpdate(e) {
    this.trace("SIGNALING UPDATE MESSGE", e), this.trace("UPDATE SDP", e.sdp), await this.setRemoteDescription(e), await this.createAnswer(e), await this.sendUpdateAnswer();
  }
  /**
   * シグナリングサーバーから受け取った type re-offer メッセージを処理をするメソッド
   *
   * @param message - type re-offer メッセージ
   */
  async signalingOnMessageTypeReOffer(e) {
    this.trace("SIGNALING RE OFFER MESSGE", e), this.trace("RE OFFER SDP", e.sdp), await this.setRemoteDescription(e), await this.createAnswer(e), await this.sendReAnswer();
  }
  /**
   * シグナリングサーバーから受け取った type disconnect メッセージを処理をするメソッド
   *
   * @param message - type disconnect メッセージ
   */
  async signalingOnMessageTypeClose(e) {
    this.trace("SIGNALING DISCONNECT MESSAGE", e), this.shutdown({ code: e.code, reason: e.reason });
  }
  /**
   * シグナリングサーバーから受け取った type ping メッセージを処理をするメソッド
   *
   * @param message - type ping メッセージ
   */
  async signalingOnMessageTypePing(e) {
    const t = {
      type: $
    };
    if (e.stats) {
      const i = await this.getStats();
      t.stats = i;
    }
    this.ws && this.ws.send(JSON.stringify(t));
  }
  /**
   * シグナリングサーバーから受け取った type notify メッセージを処理をするメソッド
   *
   * @param message - type notify メッセージ
   */
  signalingOnMessageTypeNotify(e, t) {
    e.event_type === "connection.created" && re(e), this.callbacks.notify(e, t);
  }
  /**
   * シグナリングサーバーから受け取った type switched メッセージを処理をするメソッド
   *
   * @param message - type switched メッセージ
   */
  signalingOnMessageTypeSwitched(e) {
    if (this.signalingSwitched = !0, !!this.ws) {
      e.ignore_disconnect_websocket && (this.ws && (this.ws.onclose = null, this.ws.close(), this.ws = null), this.writeWebSocketSignalingLog("close"));
      for (const t of this.datachannels)
        this.callbacks.datachannel(de(t));
    }
  }
  /**
   * シグナリングサーバーから受け取った type redirect メッセージを処理をするメソッド
   *
   * @param message - type redirect メッセージ
   */
  async signalingOnMessageTypeRedirect(e) {
    this.ws && (this.ws.onclose = null, this.ws.onerror = null, this.ws.close(), this.ws = null);
    const t = await this.getSignalingWebSocket(e.location);
    return await this.signaling(t, !0);
  }
  /**
   * sender の parameters に encodings をセットするメソッド
   *
   * @remarks
   * サイマルキャスト用の処理
   */
  async setSenderParameters(e, t) {
    const i = e.sender.getParameters();
    i.encodings = t, await e.sender.setParameters(i), this.trace("TRANSCEIVER SENDER SET_PARAMETERS", i), this.writePeerConnectionTimelineLog("transceiver-sender-set-parameters", i);
  }
  /**
   * PeerConnection から RTCStatsReport を取得するためのメソッド
   */
  async getStats() {
    const e = [];
    if (!this.pc)
      return e;
    const t = await this.pc.getStats();
    for (const [i, n] of t.entries())
      e.push(n);
    return e;
  }
  /**
   * PeerConnection の ondatachannel callback メソッド
   *
   * @param dataChannelEvent - DataChannel イベント
   */
  onDataChannel(e) {
    const t = e.channel;
    t.bufferedAmountLowThreshold = 65536, t.binaryType = "arraybuffer", this.soraDataChannels[t.label] = t, this.writeDataChannelTimelineLog(
      "ondatachannel",
      t,
      le(t)
    ), e.channel.onbufferedamountlow = (i) => {
      const n = i.currentTarget;
      this.writeDataChannelTimelineLog("onbufferedamountlow", n);
    }, e.channel.onopen = (i) => {
      const n = i.currentTarget;
      this.trace("OPEN DATA CHANNEL", n.label), n.label === "signaling" && this.ws ? this.writeDataChannelSignalingLog("onopen", n) : this.writeDataChannelTimelineLog("onopen", n);
    }, e.channel.onclose = async (i) => {
      const n = i.currentTarget;
      this.writeDataChannelTimelineLog("onclose", n), this.trace("CLOSE DATA CHANNEL", n.label), await this.disconnect();
    }, e.channel.onerror = async (i) => {
      const n = i.currentTarget;
      this.writeDataChannelTimelineLog("onerror", n), this.trace("ERROR DATA CHANNEL", n.label), await this.abend("DATA-CHANNEL-ONERROR", {
        params: { label: n.label }
      });
    }, e.channel.label === K ? e.channel.onmessage = async (i) => {
      const n = i.currentTarget, o = n.label, s = this.signalingOfferMessageDataChannels[o];
      if (!s) {
        console.warn(
          `Received onmessage event for '${o}' DataChannel. But '${o}' DataChannel settings doesn't exist`
        );
        return;
      }
      const a = await S(i.data, s.compress), c = JSON.parse(a);
      this.writeDataChannelSignalingLog(`onmessage-${c.type}`, n, c), c.type === O ? await this.signalingOnMessageTypeReOffer(c) : c.type === B && await this.signalingOnMessageTypeClose(c);
    } : e.channel.label === q ? e.channel.onmessage = async (i) => {
      const n = i.currentTarget, o = n.label, s = this.signalingOfferMessageDataChannels[o];
      if (!s) {
        console.warn(
          `Received onmessage event for '${o}' DataChannel. But '${o}' DataChannel settings doesn't exist`
        );
        return;
      }
      const a = await S(i.data, s.compress), c = JSON.parse(a);
      c.event_type === "connection.created" ? this.writeDataChannelTimelineLog("notify-connection.created", n, c) : c.event_type === "connection.destroyed" && this.writeDataChannelTimelineLog("notify-connection.destroyed", n, c), this.signalingOnMessageTypeNotify(c, "datachannel");
    } : e.channel.label === z ? e.channel.onmessage = async (i) => {
      const o = i.currentTarget.label, s = this.signalingOfferMessageDataChannels[o];
      if (!s) {
        console.warn(
          `Received onmessage event for '${o}' DataChannel. But '${o}' DataChannel settings doesn't exist`
        );
        return;
      }
      const a = await S(i.data, s.compress), c = JSON.parse(a);
      this.callbacks.push(c, "datachannel");
    } : e.channel.label === Q ? e.channel.onmessage = async (i) => {
      const o = i.currentTarget.label, s = this.signalingOfferMessageDataChannels[o];
      if (!s) {
        console.warn(
          `Received onmessage event for '${o}' DataChannel. But '${o}' DataChannel settings doesn't exist`
        );
        return;
      }
      const a = await S(i.data, s.compress);
      if (JSON.parse(a).type === H) {
        const d = await this.getStats();
        await this.sendStatsMessage(d);
      }
    } : /^#.*/.exec(e.channel.label) && (e.channel.onmessage = async (i) => {
      if (i.currentTarget === null)
        return;
      const o = i.currentTarget.label, s = this.signalingOfferMessageDataChannels[o];
      if (!s) {
        console.warn(
          `Received onmessage event for '${o}' DataChannel. But '${o}' DataChannel settings doesn't exist`
        );
        return;
      }
      const a = i.target;
      let c;
      typeof i.data == "string" ? c = new TextEncoder().encode(i.data).buffer : i.data instanceof ArrayBuffer ? c = i.data : console.warn("Received onmessage event data is not of type String or ArrayBuffer."), c !== void 0 && (s.compress === !0 && (c = await I(new Uint8Array(c))), this.callbacks.message(he(a.label, c)));
    });
  }
  /**
   * シグナリングサーバーへメッセージを送信するメソッド
   *
   * @param message - 送信するメッセージ
   */
  async sendSignalingMessage(e) {
    if (this.soraDataChannels.signaling) {
      if (this.signalingOfferMessageDataChannels.signaling && this.signalingOfferMessageDataChannels.signaling.compress === !0) {
        const t = new TextEncoder().encode(JSON.stringify(e)), i = await f(t);
        this.soraDataChannels.signaling.send(i);
      } else
        this.soraDataChannels.signaling.send(JSON.stringify(e));
      this.writeDataChannelSignalingLog(
        `send-${e.type}`,
        this.soraDataChannels.signaling,
        e
      );
    } else this.ws !== null && (this.ws.send(JSON.stringify(e)), this.writeWebSocketSignalingLog(`send-${e.type}`, e));
  }
  /**
   * シグナリングサーバーに stats メッセージを投げるメソッド
   *
   * @param reports - RTCStatsReport のリスト
   */
  async sendStatsMessage(e) {
    if (this.soraDataChannels.stats) {
      const t = {
        type: V,
        reports: e
      };
      if (this.signalingOfferMessageDataChannels.stats && this.signalingOfferMessageDataChannels.stats.compress === !0) {
        const i = new TextEncoder().encode(JSON.stringify(t)), n = await f(i);
        this.soraDataChannels.stats.send(n);
      } else
        this.soraDataChannels.stats.send(JSON.stringify(t));
    }
  }
  /**
   * audio transceiver を取得するメソッド
   */
  getAudioTransceiver() {
    return this.pc && this.mids.audio && this.pc.getTransceivers().find((t) => t.mid === this.mids.audio) || null;
  }
  /**
   * video transceiver を取得するメソッド
   */
  getVideoTransceiver() {
    return this.pc && this.mids.video && this.pc.getTransceivers().find((t) => t.mid === this.mids.video) || null;
  }
  /**
   * disconnect callback に渡す Event オブジェクトを生成するためのメソッド
   *
   * @param type - Event タイプ(normal | abend)
   * @param title - Event タイトル
   * @param initDict - Event に設定するオプションパラメーター
   */
  soraCloseEvent(e, t, i) {
    const n = class extends Event {
      constructor(s, a, c) {
        super(s), c && (c.code && (this.code = c.code), c.reason && (this.reason = c.reason), c.params && (this.params = c.params)), this.title = a;
      }
    };
    return new n(e, t, i);
  }
  /**
   * DataChannel を使用してメッセージを送信するメソッド
   *
   * @param label - メッセージを送信する DataChannel のラベル
   * @param message - Uint8Array
   */
  async sendMessage(e, t) {
    const i = this.soraDataChannels[e];
    if (this.pc === null)
      return;
    if (i === void 0)
      throw new Error("Could not find DataChannel");
    if (i.readyState !== "open")
      throw new Error("Messaging DataChannel is not open");
    const n = this.signalingOfferMessageDataChannels[e];
    if (n !== void 0 && n.compress === !0) {
      const o = await f(t);
      i.send(o);
    } else
      i.send(t);
  }
  /**
   * audio が有効かどうか
   */
  get audio() {
    return this.getAudioTransceiver() !== null;
  }
  /**
   * video が有効かどうか
   */
  get video() {
    return this.getVideoTransceiver() !== null;
  }
  /**
   * シグナリングに使用する URL
   *
   * @deprecated
   */
  get signalingUrl() {
    return this.signalingUrlCandidates;
  }
  /**
   * DataChannel メッセージング用の DataChannel 情報のリスト
   */
  get datachannels() {
    if (!this.signalingSwitched)
      return [];
    const e = Object.keys(this.signalingOfferMessageDataChannels).filter(
      (i) => /^#.*/.exec(i)
    ), t = [];
    for (const i of e) {
      const n = this.soraDataChannels[i];
      if (!n)
        continue;
      const o = this.signalingOfferMessageDataChannels[i];
      if (!o)
        continue;
      const s = {
        label: n.label,
        ordered: n.ordered,
        protocol: n.protocol,
        compress: o.compress,
        direction: o.direction,
        header: o.header
      };
      typeof n.maxPacketLifeTime == "number" && (s.maxPacketLifeTime = n.maxPacketLifeTime), typeof n.maxRetransmits == "number" && (s.maxRetransmits = n.maxRetransmits), t.push(s);
    }
    return t;
  }
}
class we extends w {
  /**
   * Sora へ接続するメソッド、legacyStream は利用できない
   *
   * @example
   * ```typescript
   * const messaging = connection.messaging("sora");
   * await messaging.connect();
   * ```
   *
   * @public
   */
  async connect() {
    await Promise.race([
      this.multiStream().finally(() => {
        this.clearConnectionTimeout(), this.clearMonitorSignalingWebSocketEvent();
      }),
      this.setConnectionTimeout(),
      this.monitorSignalingWebSocketEvent()
    ]), this.monitorWebSocketEvent(), this.monitorPeerConnectionState();
  }
  /**
   * マルチストリームで Sora へ接続するメソッド
   */
  async multiStream() {
    await this.disconnect();
    const e = await this.getSignalingWebSocket(this.signalingUrlCandidates), t = await this.signaling(e);
    await this.connectPeerConnection(t), await this.setRemoteDescription(t), await this.createAnswer(t), this.sendAnswer(), await this.onIceCandidate(), await this.waitChangeConnectionStateConnected();
  }
}
class D extends w {
  /**
   * Sora へ接続するメソッド
   *
   * @example
   * ```typescript
   * const sendrecv = connection.sendrecv("sora");
   * const mediaStream = await navigator.mediaDevices.getUserMedia({audio: true, video: true});
   * await sendrecv.connect(mediaStream);
   * ```
   *
   * @param stream - メディアストリーム
   *
   * @public
   */
  async connect(e) {
    return this.options.multistream === !1 ? await Promise.race([
      this.legacyStream(e).finally(() => {
        this.clearConnectionTimeout(), this.clearMonitorSignalingWebSocketEvent();
      }),
      this.setConnectionTimeout(),
      this.monitorSignalingWebSocketEvent()
    ]) : await Promise.race([
      this.multiStream(e).finally(() => {
        this.clearConnectionTimeout(), this.clearMonitorSignalingWebSocketEvent();
      }),
      this.setConnectionTimeout(),
      this.monitorSignalingWebSocketEvent()
    ]), this.monitorWebSocketEvent(), this.monitorPeerConnectionState(), e;
  }
  /**
   * レガシーストリームで Sora へ接続するメソッド
   *
   * @deprecated この関数は非推奨です、マルチストリームを利用してください。
   *
   * @param stream - メディアストリーム
   */
  async legacyStream(e) {
    await this.disconnect();
    const t = await this.getSignalingWebSocket(this.signalingUrlCandidates), i = await this.signaling(t);
    return await this.connectPeerConnection(i), await this.setRemoteDescription(i), e.getTracks().filter((n) => {
      this.pc && this.pc.addTrack(n, e);
    }), this.stream = e, await this.createAnswer(i), this.sendAnswer(), await this.onIceCandidate(), await this.waitChangeConnectionStateConnected(), e;
  }
  /**
   * マルチストリームで Sora へ接続するメソッド
   *
   * @param stream - メディアストリーム
   */
  async multiStream(e) {
    await this.disconnect();
    const t = await this.getSignalingWebSocket(this.signalingUrlCandidates), i = await this.signaling(t);
    return await this.connectPeerConnection(i), this.pc && (this.pc.ontrack = async (n) => {
      const o = n.streams[0];
      if (!o)
        return;
      const s = {
        "stream.id": o.id,
        id: n.track.id,
        label: n.track.label,
        enabled: n.track.enabled,
        kind: n.track.kind,
        muted: n.track.muted,
        readyState: n.track.readyState
      };
      this.writePeerConnectionTimelineLog("ontrack", s), o.id !== "default" && o.id !== this.connectionId && (this.callbacks.track(n), o.onremovetrack = (a) => {
        if (this.callbacks.removetrack(a), a.target) {
          const c = a.target.id, d = this.remoteConnectionIds.indexOf(c);
          -1 < d && delete this.remoteConnectionIds[d];
        }
      }, !(-1 < this.remoteConnectionIds.indexOf(o.id)) && this.remoteConnectionIds.push(o.id));
    }), await this.setRemoteDescription(i), e.getTracks().filter((n) => {
      this.pc && this.pc.addTrack(n, e);
    }), this.stream = e, await this.createAnswer(i), this.sendAnswer(), await this.onIceCandidate(), await this.waitChangeConnectionStateConnected(), e;
  }
}
class Te extends w {
  /**
   * Sora へ接続するメソッド
   *
   * @example
   * ```typescript
   * const recvonly = connection.sendrecv("sora");
   * await recvonly.connect();
   * ```
   *
   * @public
   */
  // biome-ignore lint/suspicious/noConfusingVoidType: stream が <MediaStream | void> なのでどうしようもない
  async connect() {
    if (this.options.multistream === !1) {
      const e = await Promise.race([
        this.legacyStream().finally(() => {
          this.clearConnectionTimeout(), this.clearMonitorSignalingWebSocketEvent();
        }),
        this.setConnectionTimeout(),
        this.monitorSignalingWebSocketEvent()
      ]);
      return this.monitorWebSocketEvent(), this.monitorPeerConnectionState(), e;
    }
    await Promise.race([
      this.multiStream().finally(() => {
        this.clearConnectionTimeout(), this.clearMonitorSignalingWebSocketEvent();
      }),
      this.setConnectionTimeout(),
      this.monitorSignalingWebSocketEvent()
    ]), this.monitorWebSocketEvent(), this.monitorPeerConnectionState();
  }
  /**
   * レガシーストリームで Sora へ接続するメソッド
   *
   * @deprecated この関数は非推奨です、マルチストリームを利用してください。
   *
   */
  async legacyStream() {
    await this.disconnect();
    const e = await this.getSignalingWebSocket(this.signalingUrlCandidates), t = await this.signaling(e);
    return await this.connectPeerConnection(t), this.pc && (this.pc.ontrack = async (i) => {
      this.stream = i.streams[0];
      const n = this.stream.id;
      if (n === "default")
        return;
      const o = {
        "stream.id": n,
        id: i.track.id,
        label: i.track.label,
        enabled: i.track.enabled,
        kind: i.track.kind,
        muted: i.track.muted,
        readyState: i.track.readyState
      };
      this.writePeerConnectionTimelineLog("ontrack", o), this.callbacks.track(i), this.stream.onremovetrack = (s) => {
        if (this.callbacks.removetrack(s), s.target) {
          const a = s.target.id, c = this.remoteConnectionIds.indexOf(a);
          -1 < c && delete this.remoteConnectionIds[c];
        }
      }, !(-1 < this.remoteConnectionIds.indexOf(n)) && this.remoteConnectionIds.push(n);
    }), await this.setRemoteDescription(t), await this.createAnswer(t), this.sendAnswer(), await this.onIceCandidate(), await this.waitChangeConnectionStateConnected(), this.stream || new MediaStream();
  }
  /**
   * マルチストリームで Sora へ接続するメソッド
   */
  async multiStream() {
    await this.disconnect();
    const e = await this.getSignalingWebSocket(this.signalingUrlCandidates), t = await this.signaling(e);
    await this.connectPeerConnection(t), this.pc && (this.pc.ontrack = async (i) => {
      const n = i.streams[0];
      if (n.id === "default" || n.id === this.connectionId)
        return;
      const o = {
        "stream.id": n.id,
        id: i.track.id,
        label: i.track.label,
        enabled: i.track.enabled,
        kind: i.track.kind,
        muted: i.track.muted,
        readyState: i.track.readyState
      };
      this.writePeerConnectionTimelineLog("ontrack", o), this.callbacks.track(i), n.onremovetrack = (s) => {
        if (this.callbacks.removetrack(s), s.target) {
          const a = s.target.id, c = this.remoteConnectionIds.indexOf(a);
          -1 < c && delete this.remoteConnectionIds[c];
        }
      }, !(-1 < this.remoteConnectionIds.indexOf(n.id)) && this.remoteConnectionIds.push(n.id);
    }), await this.setRemoteDescription(t), await this.createAnswer(t), this.sendAnswer(), await this.onIceCandidate(), await this.waitChangeConnectionStateConnected();
  }
}
class ye {
  constructor(e, t = !1) {
    this.signalingUrlCandidates = e, this.debug = t;
  }
  /**
   * role sendrecv で接続するための Connection インスタンスを生成するメソッド
   *
   * @example
   * ```typescript
   * const connection = Sora.connection('ws://192.0.2.100:5000/signaling', true);
   * const sendrecv = connection.sendrecv("sora");
   * ```
   *
   * @param channelId - チャネルID
   * @param metadata - メタデータ
   * @param options - コネクションオプション
   *
   * @returns
   * role sendrecv な Connection オブジェクトを返します
   *
   * @public
   */
  sendrecv(e, t = null, i = { audio: !0, video: !0 }) {
    return new D(
      this.signalingUrlCandidates,
      "sendrecv",
      e,
      t,
      i,
      this.debug
    );
  }
  /**
   * role sendonly で接続するための Connection インスタンスを生成するメソッド
   *
   * @param channelId - チャネルID
   * @param metadata - メタデータ
   * @param options - コネクションオプション
   *
   * @example
   * ```typescript
   * const connection = Sora.connection('ws://192.0.2.100:5000/signaling', true);
   * const sendonly = connection.sendonly("sora");
   * ```
   *
   * @returns
   * role sendonly な Connection オブジェクトを返します
   *
   * @public
   */
  sendonly(e, t = null, i = { audio: !0, video: !0 }) {
    return new D(
      this.signalingUrlCandidates,
      "sendonly",
      e,
      t,
      i,
      this.debug
    );
  }
  /**
   * role recvonly で接続するための Connection インスタンスを生成するメソッド
   *
   * @example
   * ```typescript
   * const connection = Sora.connection('ws://192.0.2.100:5000/signaling', true);
   * const recvonly = connection.recvonly("sora");
   * ```
   *
   * @param channelId - チャネルID
   * @param metadata - メタデータ
   * @param options - コネクションオプション
   *
   * @returns
   * role recvonly な Connection オブジェクトを返します
   *
   * @public
   */
  recvonly(e, t = null, i = { audio: !0, video: !0 }) {
    return new Te(
      this.signalingUrlCandidates,
      "recvonly",
      e,
      t,
      i,
      this.debug
    );
  }
  messaging(e, t = null, i = { audio: !1, video: !1 }) {
    return i.audio = !1, i.video = !1, i.multistream = !0, i.dataChannelSignaling = !0, new we(
      this.signalingUrlCandidates,
      // messaging は role sendonly として扱う
      "sendonly",
      e,
      t,
      i,
      this.debug
    );
  }
  /**
   * シグナリングに使用する URL の候補
   *
   * @public
   * @deprecated
   */
  get signalingUrl() {
    return this.signalingUrlCandidates;
  }
}
const be = {
  /**
   * SoraConnection インスタンスを生成するメソッド
   *
   * @example
   * ```typescript
   * const connection = Sora.connection('ws://192.0.2.100:5000/signaling', true);
   * ```
   *
   * @param signalingUrlCandidates - シグナリングに使用する URL 候補
   * @param debug - デバッグフラグ
   *
   * @public
   *
   */
  connection: (r, e = !1) => new ye(r, e),
  /**
   * SDK のバージョンを返すメソッド
   *
   * @public
   */
  version: () => "2024.2.2",
  /**
   * WebRTC のユーティリティ関数群
   *
   * @public
   */
  helpers: {
    applyMediaStreamConstraints: _
  }
};
export {
  be as default
};
