import { default as ConnectionBase } from './base';
/**
 * Role が "recvonly" の場合に Sora との WebRTC 接続を扱うクラス
 */
export default class ConnectionSubscriber extends ConnectionBase {
    /**
     * Sora へ接続するメソッド
     *
     * @example
     * ```typescript
     * const recvonly = connection.sendrecv("sora");
     * await recvonly.connect();
     * ```
     *
     * @public
     */
    connect(): Promise<MediaStream | void>;
    /**
     * レガシーストリームで Sora へ接続するメソッド
     *
     * @deprecated この関数は非推奨です、マルチストリームを利用してください。
     *
     */
    private legacyStream;
    /**
     * マルチストリームで Sora へ接続するメソッド
     */
    private multiStream;
}
